var exec = require('cordova/exec');


exports.optIn = function (success, error) {
  exec(success, error, 'Contentsquare', "optIn");
};

exports.optOut = function (success, error) {
  exec(success, error, 'Contentsquare', "optOut");
};

exports.sendScreenName = function (arg0, success, error) {
  exec(success, error, 'Contentsquare', "sendScreenName", [arg0]);
};

exports.handleURL = function (url, success, error) {
  exec(success, error, 'Contentsquare', "handleURL", [url]);
};

exports.sendTransaction = function (transactionItem, success, error) {
  if (transactionItem.transactionId) {
    exec(success, error, 'Contentsquare', "sendTransaction", [transactionItem.transactionValue, transactionItem.transactionCurrency, transactionItem.transactionId]);
  } else {
    exec(success, error, 'Contentsquare', "sendTransaction", [transactionItem.transactionValue, transactionItem.transactionCurrency, ""]);
  }
};

exports.sendDynamicVar = function (dynamicVarItem, success, error) {
  try {
    const dynVarValue = dynamicVarItem['dynVarValue'];
    if (typeof dynVarValue === 'string') {
      exec(success, error, 'Contentsquare', "sendDynamicVarWithStringValue", [dynamicVarItem.dynVarKey, dynamicVarItem.dynVarValue]);
    } else if (Number.isInteger(dynVarValue) && dynVarValue >= 0) {
      exec(success, error, 'Contentsquare', "sendDynamicVarWithIntValue", [dynamicVarItem.dynVarKey, dynamicVarItem.dynVarValue]);
    } else {
      let callbackError = TypeError("The value of the DynamicVar should be either a string or an unsigned integer")
      if (typeof error === 'function') {
        error(callbackError)
      } else {
        console.log(callbackError.message)
      }
    }
  } catch (err) {
    error(err);
  }
};
